/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GD_MACRO_H_
#define _KLIC_GD_MACRO_H_

#include <klic/stdc.h>  /* CONCATENATE */
#include <klic/functorstuffs.h>  /* functors, arities */
#include <klic/basic.h>  /* fatal, klic_fprintf, klic_putc */
#include <klic/g_basic.h>

/* runtime/unify2.c */
extern q eq_terms_body(q x, q y);

/* runtime/generic.c */
extern void GD_MAKE_GENERIC_GOAL(
  struct goalrec** goalp1, q var,
  unsigned long method_functor, q argv[] );

#define GD_guard(fa) G_guard0(CLASS_NAME,fa)
#define GD_body(fa) G_body0(CLASS_NAME,fa)

#define GD_USE_CLASS(class) \
extern const struct data_object_method_table G_method_table0(class)

#define GD_UNIFY_FAIL \
  G_error("Failure", "active unification", "data", G_CLASS_NAME_STRING)
#define GD_ERROR_IN_METHOD(errmsg, methodname) \
  G_error((errmsg), (methodname), "data", G_CLASS_NAME_STRING)

/**************************************************/
#define GD_ALLOC_AREA(new,type,size) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((new), (size), type, res); \
  if(res == GENERIC_GCREQUEST){ \
    struct goalrec *goal; \
    GD_MAKE_GENERIC_GOAL(&goal, makefunctor(g_self), g_method_functor, \
			 g_argv ); \
    resume_same_prio(goal); \
    return; \
  } \
}while(0)

#define GD_ALLOC_AREA_FOR_NEW(new,type,size) \
do{ \
  q res; \
  G_HEAPALLOC_WITH_CHECK((new), (size), type, res); \
  if(res == GENERIC_GCREQUEST){ \
    q var; \
    struct goalrec *goal; \
    G_MAKE_THE_NEW_GOAL(&var, &goal, g_myself, g_argc, g_argv); \
    resume_same_prio(goal); \
    return var; \
  } \
}while(0)

/***************************************************************************/

#define GDSET_NEWOBJ(newgobj) \
do{ \
  GD_ALLOC_AREA((newgobj), (G_OBJ_TYPE*), G_OBJ_SIZE); \
  (newgobj)->method_table = g_self->method_table; \
}while(0)

/***************************************************************************/
#define GD_GDEREF(x) \
do{ \
  while( isref(x) ){ \
    q temp0 = derefone(x); \
    if( isref(temp0) && (x) == derefone(temp0) ){ \
      return (x); \
    } else { \
      (x) = temp0; \
    } \
  } \
}while(0)

#define GD_DEREF(x) \
do{ \
  while( isref(x) ){ \
    q temp0 = derefone(x); \
    if( isref(temp0) && (x) == derefone(temp0) ){ \
      struct goalrec* goal; \
      GD_MAKE_GENERIC_GOAL(&goal, makefunctor(g_self), \
    			g_method_functor, g_argv ); \
      G_SUSPEND((x), goal); \
      return; \
    } else { \
      (x) = temp0; \
    } \
  } \
}while(0)

/****************************************************/
#define GD_METHOD_CASE_DIRECT(fa)  case (long) G_functor(fa)

#define GD_METHOD_CASE(fa) \
 case (long) G_functor(fa): \
  GD_body(fa) (g_self, g_method_functor, g_argv); \
  break

#define GD_METHOD_CASE_DEFAULT  default: fatal("undefined method")

#define GD_METHOD_NAME_CASE(sym) \
 case ((long)(G_atom(sym))) : \
  GD_body(sym)(g_self, g_method_functor, g_argv); \
  break

#define GDDEF_METHOD(fa) \
static void GD_body(fa) (G_OBJ_TYPE* g_self, long g_method_functor, q* g_argv)

/**********************************************************************/
#define GDDEF_GUNIFY() \
static q G_rappend(passive_unify) (G_OBJ_TYPE* g_self, G_OBJ_TYPE* GD_OTHER)

#define GDDEF_UNIFY() \
static void G_rappend(active_unify) (G_OBJ_TYPE* g_self, G_OBJ_TYPE* GD_OTHER)

#define GD_PUTC(x)  klic_putc((x), g_fp)

#define GD_PRINTF(s, arg) \
do{ klic_fprintf(g_fp, (s), (arg)); }while(0)

#define GD_PRINT_KL1_TERM(x) \
do{ general_print((x), g_fp, g_depth, g_length); }while(0)

#define GD_PRINT_KL1_TERMS(x,b,s) \
do{ \
  int i; \
  general_print(((q*) (x))+(b), g_fp, g_depth, g_length); \
  for(i=(b)+1; i<(b)+(s); i++){ \
    klic_fprintf(g_fp,","); \
    general_print(((q*) (x))+i, g_fp, g_depth, g_length); \
  } \
}while(0)

/******************************************************************/

#define GDDEF_COMPARE() \
static q G_rappend(compare) (G_OBJ_TYPE* g_self, G_OBJ_TYPE* GD_OTHER)

#define GDDEF_HASH() \
static q G_rappend(hash) (G_OBJ_TYPE* g_self, long GD_LEVEL)

#define GDDEF_GENERIC() \
static void \
G_rappend(generic) (G_OBJ_TYPE* g_self, long g_method_functor, q* g_argv)

/**********************************************************************/
/*  guard utility */
#define GDDEF_GGENERIC() \
static q G_rappend(guard_generic) \
  (G_OBJ_TYPE* g_self, long g_method_functor, q* g_argv)

#define GD_GMETHOD_CASE(fa) \
 case (long) G_functor(fa): \
  return (q) GD_guard(fa) (g_self, g_method_functor, g_argv);

#define GDDEF_GMETHOD(fa) \
static q GD_guard(fa) (G_OBJ_TYPE* g_self, long g_method_functor, q* g_argv)

#define GD_GMETHOD_CASE_DEFAULT \
  default: \
  return GENERIC_FAILED

/*******************************************/
/* utility */
#define GDSET_INTARG_FOR_NEW(var,argv_i) \
do{ \
  while( !isint(argv_i) ){ \
    if( !isref(argv_i) ){ \
      G_ERROR_IN_NEW("Non-integer parameter"); \
    } \
    G_DEREF_FOR_NEW(argv_i); \
  } \
  (var) = intval(argv_i); \
}while(0)

#define GDSET_SYMARG_FOR_NEW(var, arg) \
do{ \
  while( !issym(arg) ){ \
    if( !isref(arg) ) G_ERROR_IN_NEW("Non-atom paramter"); \
    G_DEREF_FOR_NEW(arg); \
  } \
  (var) = (arg); \
}while(0)

#define GDSET_INTARG_WITHIN_RANGE(var,argv_i,llim,ulim) \
do{ \
  while( !isint(argv_i) ){ \
    if( !isref(argv_i) ) GD_ERROR_IN_METHOD("Non-integer paramter", 0); \
    GD_DEREF(argv_i); \
  } \
  (var) = intval(argv_i); \
  if ((var) < (llim) || (ulim) <= (var)) \
    GD_ERROR_IN_METHOD("out of range", 0); \
}while(0)

#define GDSET_GINTARG_WITHIN_RANGE(var,x,from,to) \
do{ \
  while( !isint(x) ){ \
    if( !isref(x) ) return GENERIC_FAILED; \
    GD_GDEREF(x); \
  } \
  (var) = intval(x); \
  if( (var) < (from) || (to) <= (var) ) return GENERIC_FAILED; \
}while(0)

/*******************************************/

#define GD_CALL_GMETHOD(obj,method,argv) \
  ((q) ((struct data_object*) functorp(obj))->method_table->g_generic \
         ((struct data_object*) functorp(obj), G_functor(method), (argv)) )

#endif /* _KLIC_GD_MACRO_H_ */
