/* ---------------------------------------------------------- 
%   (C)1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */
#include <stdio.h>
#include <klic/gdobject.h>  /* fatal, klic_fprintf */
#include "interpe.h"
#include <klic/distio.h>

#include "atom.h"
#include "funct.h"

#define CLASS_NAME  read_hook
#define G_OBJ_TYPE  struct read_hook_object
#define G_OBJ_SIZE  G_SIZE_IN_Q(G_OBJ_TYPE)

#include <klic/gc_macro.h>
#include <klic/gd_macro.h>

struct read_hook_object{
  struct consumer_object_method_table* method_table;
  long node;
  long index;
  long wec;
  q to_read_hook;
  long return_index;
};

GCDEF_UNIFY()
{
  G_STD_DECL;

  G_SWITCH_ON_TERM(list0, atomic0, functor0, generic_data0, susp0);

 list0:
 atomic0:
 functor0:
 generic_data0:
  if( receive_answer_flag ){
    if( g_self->return_index == answer_return_exp_index ){
      INT_CL_DEBUG_X
	(klic_fprintf(stdout, "rdhok receive answer value -> send_release\n"));
      send_release(g_self->node, g_self->index, g_self->wec);
    }else{
      INT_CL_DEBUG_X
	(klic_fprintf(stdout, "rdhok receive answer value -> send_unify\n"));
      send_unify(g_self->node, g_self->index, g_self->wec, g_term);
    }
  }else{
    INT_CL_DEBUG_X(klic_fprintf(stdout, "rdhok active unify -> send_unify\n"));
    send_unify(g_self->node, g_self->index, g_self->wec, g_term);
    /* g_self->method_table = NULL; */
  }
  g_self->node = 0;
  g_self->index = 0;
  g_self->wec = 0;
  GC_TERMINATE;

 susp0:
  fatal("invalid data for unify rdhok");
}

G_DEF_GC()
{
  G_STD_DECL;
  G_OBJ_TYPE* newself;

  INT_CL_DEBUG_X(klic_fprintf(stdout, "readhook GC invoked\n"));

  G_SET_NEWOBJ_IN_NEWGEN(newself);

  newself->node = g_self->node;
  newself->index = g_self->index;
  newself->wec = g_self->wec;
  newself->return_index = g_self->return_index;

  G_COPY_KL1_TERM_TO_NEWGEN(g_self->to_read_hook, newself->to_read_hook);

  G_RETURN_FROM_GC(newself);
}

#define GCUSE_MY_UNIFY
#define GCUSE_MY_GC

#include <klic/gc_methtab.h>

G_DEF_NEW() /* node, index, wec */
{
  G_STD_DECL_FOR_NEW();
  G_OBJ_TYPE* new_read_hook;

  G_SET_NEWOBJ_FOR_NEW(new_read_hook, G_OBJ_SIZE);
  new_read_hook->node  = (long) intval(g_argv[0]);
  new_read_hook->index = (long) intval(g_argv[1]);
  new_read_hook->wec   = (long) intval(g_argv[2]);

  new_read_hook->to_read_hook =
    GC_MAKE_HOOK_VAR((struct consumer_object*) new_read_hook);

  new_read_hook->return_index = send_read(new_read_hook->node,
					  new_read_hook->index,
					  new_read_hook->to_read_hook,
					  TRANSFER_CNT );
  new_read_hook->wec--;     /* WEC of EXREF in %read is 1 */
  return new_read_hook->to_read_hook;
}
