/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */
#include <stdio.h>
#include <klic/gdobject.h>  /* fatal */
#include "atom.h"
#include "funct.h"

#define CLASS_NAME  reply_hook
#define G_OBJ_TYPE  struct reply_hook_object
#define G_OBJ_SIZE  G_SIZE_IN_Q(G_OBJ_TYPE)

#include <klic/gc_macro.h>
#include <klic/gd_macro.h>

struct reply_hook_object{
  struct consumer_object_method_table* method_table;
  long node;
  long index;
  long wec;
};

GCDEF_UNIFY()
{
  G_STD_DECL;

  /* INT_CL_DEBUG_X(printf("replyhook active unify\n")); */

  G_SWITCH_ON_TERM(list0, atomic0, functor0, generic_data0, susp0);

 list0:
 atomic0:
 functor0:
 generic_data0:
  send_answer_value(g_term, g_self->node, g_self->index, g_self->wec);
  GC_TERMINATE;

 susp0:
  fatal("invalid data for unify rhook");
}

G_DEF_GC()
{
  G_STD_DECL;
  G_OBJ_TYPE* newself;

  G_SET_NEWOBJ_IN_NEWGEN(newself);
  newself->node = g_self->node;
  newself->index = g_self->index;
  newself->wec = g_self->wec;

  G_RETURN_FROM_GC(newself);
}

#define GCUSE_MY_UNIFY
#define GCUSE_MY_GC

#include <klic/gc_methtab.h>

G_DEF_NEW() /* node, index, wec */
{
  G_STD_DECL_FOR_NEW();
  G_OBJ_TYPE* new_reply_hook;
  q var;

  G_SET_NEWOBJ_FOR_NEW(new_reply_hook, G_OBJ_SIZE);
  new_reply_hook->node  = intval(g_argv[0]);
  new_reply_hook->index = intval(g_argv[1]);
  new_reply_hook->wec   = intval(g_argv[2]);

  var = GC_MAKE_HOOK_VAR((struct consumer_object*) new_reply_hook);
  return var;
}
