/* ---------------------------------------------------------- 
%   (C)1993, 1994 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_TIMING_H_
#define _KLIC_TIMING_H_

#include <sys/types.h>

#ifndef FIELD_DIFF
#define FIELD_DIFF(field)  ((unsigned long) after.field - before.field)
#endif


#ifdef GETRUSAGE

#include <sys/time.h>
#include <sys/resource.h>

#define  DIFF_USEC(field) \
  (FIELD_DIFF(field.tv_sec) * 1000000LU + FIELD_DIFF(field.tv_usec))

#define	measure(adr)  getrusage(RUSAGE_SELF, (adr))
#define USER_TIME    (DIFF_USEC(ru_utime) / 1000LU)
#define SYSTEM_TIME  (DIFF_USEC(ru_stime) / 1000LU)
#define TOTAL_TIME   ((DIFF_USEC(ru_utime) + DIFF_USEC(ru_stime)) / 1000LU)

typedef struct rusage timerstruct;


#else  /* not GETRUSAGE */

#include <sys/times.h>
#include <sys/param.h>

#define	 TICK_TO_MSEC(n)  ((unsigned long) ((n)*1000.0/HZ))

#define	measure(adr)  times(adr)
#define USER_TIME    (TICK_TO_MSEC(FIELD_DIFF(tms_utime)))
#define SYSTEM_TIME  (TICK_TO_MSEC(FIELD_DIFF(tms_stime)))
#define TOTAL_TIME   (TICK_TO_MSEC(FIELD_DIFF(tms_utime)) + TICK_TO_MSEC(FIELD_DIFF(tms_stime)))

typedef struct tms timerstruct;

#endif  /* not GETRUSAGE */


/* gc.c */
extern int gctimes(void);
extern int gcums(void);
extern int gcsms(void);

/* kmain.c */
extern int measure_gc(void);

#endif /* _KLIC_TIMING_H_ */
